/* ----------------------------------------------------------------------------
 *  codingSpace - 19					
 * ----------------------------------------------------------------------------
 *  fractals
 * ----------------------------------------------------------------------------
 *  prog: eddi.lecesne@zhdk.ch
 * ----------------------------------------------------------------------------
 * 09.11.2010
 */


class Fractal {

  PGraphics pg;
  float radius;
  float eR;
  
  

  Fractal(PGraphics pg, float r, float eR) {
    this.pg = pg;
    this.radius = r;
    this.eR = eR;
  }

  void draw()
  {
    randomSeed(millis());  // seed random
    this.pg.beginDraw();
    pushStyle();
    this.pg.smooth();           // aktiviere antialiasing
    this.pg.strokeWeight(5);    // linienbreite
    this.pg.pushMatrix();
    this.pg.translate(this.pg.width *.5, this.pg.height -20);
    this.pg.stroke(2);
     wurzel(7);
     
    //this.pg.line(0,0, this.pg.width, this.pg.height);
    this.pg.popMatrix();
    popStyle();
    this.pg.endDraw();
  }

  // funktion
  void wurzel(int tiefe)
  {  
    int depth= 50;

    if(tiefe <=0)    // teste ob das ende erreicht worden ist
    {
      // zeichen blueten
      pushStyle();
      int clr = (int)random(100,255);
      figure(true, depth, 0.0, 0.0);
      popStyle();
      return;
    }

    // zeichne zweige
    int x;
    int y;

    int count = (int)random(1,2);    //tiefe
    for(int i = 0; i < count;i++)
    {
      x = (int)random(-100,100);
      y = -(int)random(10,150);

      this.pg.noFill();
      //line(0,0,x,y);

      this.pg.pushMatrix();
      this.pg.translate(x,y);
      this.pg.scale(random(.3,.95));
      wurzel(tiefe-1);
      this.pg.popMatrix();

    }
  }
  //parameter: [ellipse or line], [rekursiv deepnes], [start of older x & y value (needed for recursion)]
  void figure(boolean select, float depth, float x_old, float y_old) {  
    float x=0;
    float y=0;
    float r = 0;  //radius

    for(float theta=0; theta<50; theta+=0.1) {  //incement angle

      r=theta*this.radius;  //increase radius (multiplicator can be changed to in-/decrease spiral size)

      // Polar to Cartesian conversion
      x = (r * cos(theta));  //calculate x coordinate from radius r and angle
      y = (r * sin(theta));  //calculate x coordinate from radius r and angle
      
      if(select) {  //true: then ellipse

        this.pg.ellipse(x, y, this.eR, this.eR);
      }
      else {  //false: then point
        this.pg.point(x,y);
      }  
      
    }
    //recursion
    if(depth>0) {
      rotate(PI/4.0);
      figure(false, depth-=1, depth*40.0*cos(depth),depth*40.0*sin(depth));  //recursive call
    }
  }
}

