/* ----------------------------------------------------------------------------
 *  codingSpace - 19					
 * ----------------------------------------------------------------------------
 *  fractal painter
 * ----------------------------------------------------------------------------
 *  prog: eddi.lecesne@zhdk.ch
 * ----------------------------------------------------------------------------
 * 13.11.2010
 */
PGraphics[] pg;
PGraphics main;
final int OFFSET = 300;
final int OFFSET_MAIN = 100;
final int QUADRANT =300;
boolean drawMainPg = false;
boolean drawMainOnce = true;
boolean resetFlag = false;
int QuadrantSelected;
int fieldId=0;
String radiusText, ellipseText;

int mX;
int mY;

Field[] field;
Button start, reset;
Slider radius, ellipseRadius;
Fractal fractal;
float radiusFloat, ellipseFloat;


void setup()  //initialize
{  
  size(1200, 900);
  pg = new PGraphics[9];
  QuadrantSelected = 0;
  field = new Field[9];
  start = new Button(60, 300, 45, 20, "create");
  reset = new Button(160, 300, 40, 20, "reset");
  radius = new Slider(60,350,100,40,.5);
  ellipseRadius = new Slider(110, 350, 100, 40,0.5);
  radiusText = "";
  ellipseText = "";
  radiusFloat = 5;
  ellipseFloat = 8;

  for(int i=0; i<9; i++) {

    pg[i] = createGraphics((height/3),(height/3),JAVA2D);
    pg[i].beginDraw();
    pg[i].fill(255, 255, 255, 255);
    pg[i].noStroke();
    pg[i].rect(0,0, pg[i].width, pg[i].height);
    pg[i].endDraw();
  }
  //inizialize the 9 pgraphics fields
  int j = 0;
  for(int i=0; i<3; i++) {
    for(int k=0; k<3; k++) {
      field[j]= new Field(OFFSET+(QUADRANT*i), k*QUADRANT, QUADRANT, j);
      j++;
    }
  }
  main = pg[fieldId];
}
void draw() {

  background(0, 0, 0, 0);

  pushMatrix();

  scale(0.70);
  translate(60,50);
  image(main, 0, 0);
  popMatrix();

  //draw the 9 pgraphics field
  int j = 0;
  for(int i=0; i<3; i++) {
    for(int k=0; k<3; k++) {
      image(pg[j], OFFSET+(i*QUADRANT), k*QUADRANT);
      field[j].draw();
      field[j].mouseOver(mouseX,mouseY);

      j++;
    }
  }
  //start button
  start.draw();
  start.mouseOver(mouseX,mouseY);
  reset.draw();
  reset.mouseOver(mouseX,mouseY);

  //radius of spiral slider
  radius.draw(); 
  radius.mouseOver(mouseX, mouseY);
  text(radiusText, 70, 480);

  //ellipse (circle) radius slider
  ellipseRadius.draw();
  ellipseRadius.mouseOver(mouseX, mouseY);
  text(ellipseText, 130, 480);

  //draw my (chosen) fractal in main window (draw flag is set in the mousePressed method)
  if(drawMainPg) {
    main = pg[fieldId];
    fractal = new Fractal(main, radiusFloat, ellipseFloat);
    fractal.draw();
    drawMainPg = false;
  }
  if(resetFlag) {
    int j2 = 0;
    for(int i=0; i<3; i++) {
      for(int k=0; k<3; k++) {
        pg[j2].beginDraw();
        pg[j2].background(255);
        pg[j2].endDraw();        
        main.beginDraw();
        main.background(255);
        main.endDraw();
        j2++    ;
      }
    }
    resetFlag = false;
  }
}

void mousePressed() {
  start.mousePress(mouseX, mouseY);  //start button 'pressed'
  reset.mousePress(mouseX, mouseY);  //reset button 'pressed'
  radius.mousePos(mouseX,mouseY,true);
  ellipseRadius.mousePos(mouseX,mouseY,true);

  //do not turn red glow-around-field when button or sliders are pressed
  if(!start.isHit(mouseX, mouseY) && !radius.isHit(mouseX, mouseY) && !ellipseRadius.isHit(mouseX, mouseY) && !reset.isHit(mouseX, mouseY)) {  
    for (int i=0; i<9; i++)
      field[i].setPressed(false);  //if another field is pressed, deactivate the last red glow

    //check which field has been pressed and save field id
    for(int i=0; i<9; i++) {
      if(field[i].isHit(mouseX, mouseY)) {
        fieldId = field[i].mousePress(mouseX, mouseY);
        println("field id: "+fieldId);
      }
    }
  }
  //set draw flag to true when start is hit (field id is by then known)
  if(start.isHit(mouseX, mouseY)) {
    println("start id: "+fieldId +" " +radiusFloat +" " +ellipseFloat);
    drawMainPg = true;
  }
  //reset all fields
  if(reset.isHit(mouseX, mouseY)) {
    println("reset");
    resetFlag = true;
  }
}
void mouseReleased() {
}
void mouseMoved() {
}
void mouseDragged() {
  radius.mousePos(mouseX,mouseY,true);
  radiusText = Float.toString(5+(radius.pos()*40.0));
  radiusFloat = 5+(radius.pos()*40.0);

  ellipseRadius.mousePos(mouseX,mouseY,true);
  ellipseText = Float.toString(8+(ellipseRadius.pos()*128.0));
  ellipseFloat = 8+(ellipseRadius.pos()*128.0);
}

